"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-unused-vars */
var faker_1 = require("@faker-js/faker");
var http_1 = require("../../errors/http");
var controller_1 = require("../../utils/controller");
var AwsProxyRouter_1 = __importDefault(require("../AwsProxyRouter"));
var BaseRouter_1 = __importDefault(require("../BaseRouter"));
describe('AwsProxyRouter', function () {
    it('Should route succesfully', function () { return __awaiter(void 0, void 0, void 0, function () {
        var controllerResult, path, httpMethod, router, handler, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    controllerResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    path = '/resource/';
                    httpMethod = 'GET';
                    router = new AwsProxyRouter_1.default();
                    router.use(path, (0, controller_1.createController)({
                        get: function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, controllerResult];
                            });
                        }); },
                    }));
                    handler = router.expose();
                    return [4 /*yield*/, handler({ path: path, httpMethod: httpMethod }, {})];
                case 1:
                    response = _a.sent();
                    expect(response).toEqual(controllerResult);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Should route succesfully even if method is in lower case', function () { return __awaiter(void 0, void 0, void 0, function () {
        var controllerResult, path, httpMethod, router, handler, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    controllerResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    path = '/resource/';
                    httpMethod = 'get';
                    router = new AwsProxyRouter_1.default();
                    router.use(path, (0, controller_1.createController)({
                        get: function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, controllerResult];
                            });
                        }); },
                    }));
                    handler = router.expose();
                    return [4 /*yield*/, handler({ path: path, httpMethod: httpMethod }, {})];
                case 1:
                    response = _a.sent();
                    expect(response).toEqual(controllerResult);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Should route through many resources', function () { return __awaiter(void 0, void 0, void 0, function () {
        var getResult, postResult, router, handler, response, response2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    postResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    router = new AwsProxyRouter_1.default();
                    router.use('/res1/', (0, controller_1.createController)({
                        get: function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, getResult];
                            });
                        }); },
                    }));
                    router.use('/res2/', (0, controller_1.createController)({
                        post: function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, postResult];
                            });
                        }); },
                    }));
                    handler = router.expose();
                    return [4 /*yield*/, handler({ path: '/res1/', httpMethod: 'GET' }, {})];
                case 1:
                    response = _a.sent();
                    expect(response).toEqual(getResult);
                    return [4 /*yield*/, handler({ path: '/res2/', httpMethod: 'POST' }, {})];
                case 2:
                    response2 = _a.sent();
                    expect(response2).toEqual(postResult);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Should return an error if resource does not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
        var getResult, get, router, handler, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    get = function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, getResult];
                        });
                    }); };
                    router = new AwsProxyRouter_1.default();
                    router.use('/resource/', (0, controller_1.createController)({
                        get: get,
                    }));
                    handler = router.expose();
                    return [4 /*yield*/, handler({ path: '/res1/', httpMethod: 'GET' }, {})];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual(BaseRouter_1.default.errorToHttpError(http_1.NotFoundError));
                    return [2 /*return*/];
            }
        });
    }); });
    it('Should return an error if handler does not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
        var getResult, get, router, handler, error, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getResult = { statusCode: 200, body: faker_1.faker.datatype.string() };
                    get = function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, getResult];
                        });
                    }); };
                    router = new AwsProxyRouter_1.default();
                    router.use('/resource/', (0, controller_1.createController)({
                        get: get,
                    }));
                    handler = router.expose();
                    return [4 /*yield*/, handler({ path: '/resource/', httpMethod: 'POST' }, {})];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual(BaseRouter_1.default.errorToHttpError(http_1.NotFoundError));
                    return [2 /*return*/];
            }
        });
    }); });
});
