"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-unused-vars */
var faker_1 = require("@faker-js/faker");
var AwsProxyRouter_1 = __importDefault(require("../AwsProxyRouter"));
var methods = ['post', 'get', 'put', 'delete'];
var hasPathArguments = function (path) { return path.includes(':'); };
var getRandomPath = function () { return "".concat(faker_1.faker.random.alphaNumeric(10)).concat(faker_1.faker.datatype.boolean() ? '/:id' : ''); };
var getRandomMethod = function () { return methods[faker_1.faker.datatype.number({ min: 0, max: methods.length - 1 })]; };
var getEmptyArray = function (length) { return Array.from(new Array(length)); };
var getArrayOfPaths = function (length) { return getEmptyArray(length).map(getRandomPath); };
var getArrayOfRoutes = function (paths) {
    return paths.map(function (path) { return ({
        controller: jest.fn().mockResolvedValue({ statusCode: 200, body: path }),
        method: getRandomMethod(),
        path: path,
    }); });
};
var length = 50000;
console.log("Creating array of ".concat(length, " routes"));
var arrayOfRoutes = getArrayOfRoutes(getArrayOfPaths(length));
var start = 0;
var mid = arrayOfRoutes.length / 2;
var end = arrayOfRoutes.length - 1;
var arrayOfRoutesPart1 = arrayOfRoutes.slice(start, mid);
var arrayOfRoutesPart2 = arrayOfRoutes.slice(mid + 1, end);
console.log('Array of routes created. First array len', arrayOfRoutesPart1.length, 'second array len', arrayOfRoutesPart2.length, 'total', arrayOfRoutesPart1.length + arrayOfRoutesPart2.length);
describe('BaseRouter.ts test', function () {
    var handler, totalTime;
    it('Should add 50K routes in less than 100 ms', function () {
        var router = new AwsProxyRouter_1.default();
        var startTime = performance.now();
        router.use(arrayOfRoutesPart1);
        router.use(arrayOfRoutesPart2);
        var endTime = performance.now();
        handler = router.expose();
        totalTime = endTime - startTime;
        console.log('Router exposed after', totalTime, 'ms');
    }, 100);
    function test(route) {
        var _this = this;
        var controller = route.controller, path = route.path, method = route.method;
        it("Check if path ".concat(method, " ").concat(path, " is available"), function () { return __awaiter(_this, void 0, void 0, function () {
            var hasArgumentPath, pathWithArgs, result, statusCode, body, mockController;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        hasArgumentPath = hasPathArguments(path);
                        pathWithArgs = hasArgumentPath ? "".concat(path.replace('/:id', '/id')) : path;
                        return [4 /*yield*/, handler({ path: "/".concat(pathWithArgs), httpMethod: method }, {})];
                    case 1:
                        result = _a.sent();
                        statusCode = result.statusCode, body = result.body;
                        mockController = controller;
                        expect(body).toEqual(path);
                        expect(statusCode).toEqual(200);
                        expect(mockController).toBeCalledTimes(1);
                        expect(mockController).toHaveBeenCalledWith(expect.objectContaining({
                            httpMethod: method,
                            path: "/".concat(pathWithArgs),
                            pathParameters: {
                                id: 'id',
                            },
                        }), expect.objectContaining({}));
                        return [2 /*return*/];
                }
            });
        }); });
    }
    arrayOfRoutesPart2
        .filter(function (_a) {
        var path = _a.path;
        return hasPathArguments(path);
    })
        .slice(0, 100)
        .forEach(test);
});
